CON
  XWIDTH_MAX = 32
  YWIDTH_MAX = 15
  XPOS_COMMAND = $0A
  YPOS_COMMAND = $0B
  COLOR_COMMAND = $0C
      
VAR
  long winBuffer_ptr
  byte title[XWIDTH_MAX] 'reserve memory for the window title
  byte winBuffer[XWIDTH_MAX*YWIDTH_MAX]
  byte textField[XWIDTH_MAX*YWIDTH_MAX]
  byte xpos
  byte ypos
  
' init: in objectoriented programming this should be the constructor
PUB init
  'bytemove(@winBuffer,string(13,"yes  "),100)    ' string copy
  winBuffer_ptr:=@winBuffer
  setPos(1,1)
  setTitle(string("title ?"))
  setText(string("--------"))

' returns a pointer to a string which represents the window content
PUB update | stringptr,n
  winBuffer_ptr:=@winBuffer

  makePos(xpos,ypos)
  makeColor(6)

  'copy title
  stringptr:=@title
  repeat
    byte[winBuffer_ptr++]:=byte[stringptr++]
  while byte[stringptr]<>0
   
  makePos(xpos,ypos+1)
  makeColor(7)
  'copy textField   
  stringptr:=@textField
  repeat
    byte[winBuffer_ptr++]:=byte[stringptr++]
  while byte[stringptr]<>0
  
  byte[winBuffer_ptr]:=0 'string termination sign
  
  result:=@winBuffer

 
PUB setTitle(stringptr)|ptr
  ptr:=@title 
  repeat
    byte[ptr++] :=byte[stringptr++]
  while byte[stringptr]<>0
  byte[ptr]:=0

PUB setText(stringptr)|ptr
  'repeat n from 0 to strsize(stringptr)
    'textField[n]:=byte[stringptr++]
  ptr:=@textField 
  repeat
    byte[ptr++] :=byte[stringptr++]
  while byte[stringptr]<>0
  byte[ptr]:=0
    
PUB setPos(x,y)
  xpos:=x
  ypos:=y

PRI makePos(x,y)
  byte[winBuffer_ptr++]:=XPOS_COMMAND
  byte[winBuffer_ptr++]:=x
  byte[winBuffer_ptr++]:=YPOS_COMMAND
  byte[winBuffer_ptr++]:=y

PRI makeColor(color)
  byte[winBuffer_ptr++]:=COLOR_COMMAND
  byte[winBuffer_ptr++]:=color
 

